/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.71 by edhill, Wed Mar 10 23:34:04 2004 UTC revision 1.83 by adcroft, Tue Jul 6 18:06:49 2004 UTC
# Line 1  Line 1 
1  #! /usr/bin/env bash  #! /usr/bin/env sh
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 67  expand_pkg_groups() { Line 67  expand_pkg_groups() {
67          done          done
68          PACKAGES=$new_packages          PACKAGES=$new_packages
69          rm -f ./p[1,2].tmp          rm -f ./p[1,2].tmp
70            return $matched
71      else      else
72          echo "Warning: can't read package groups definition file: $PKG_GROUPS"          echo "Warning: can't read package groups definition file: $PKG_GROUPS"
73      fi      fi
74  }  }
75    
76    #  Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
77    #  cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
78    check_for_broken_Ff()  {
79        #  Do we have defaults for $FS and/or $FS90 ?
80        tfs=f
81        tfs9=f90
82        if test "x$FS" != x ; then
83            tfs="$FS"
84        fi
85        if test "x$FS90" != x ; then
86            tfs9="$FS90"
87        fi
88    
89        #  First check the ability to create a *.F/.f pair.
90        cat <<EOF >> genmake_hello.F
91          program hello
92          write(*,*) 'hi'
93          stop
94          end
95    EOF
96        cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
97        RETVAL=$?
98        if test "x$RETVAL" != x0 ; then
99            if test "x$FS" = x ; then
100                FS='for'
101                FS90='fr9'
102                check_for_broken_Ff
103            else
104                cat <<EOF 2>&1
105    ERROR: Your file system cannot distinguish between *.F and *.f files
106      (fails the "cp" test) and this program cannot find a suitable
107      replacement extension.  Please try a different build environment or
108      contact the <MITgcm-support@mitgcm.org> list for help.
109    
110    EOF
111                exit -1
112            fi
113            return
114        fi
115        rm -f genmake_hello.*
116    
117        #  Check the ability of ${MAKE} and ${LN} to use the current set
118        #  of extensions.
119        cat <<EOF >> genmake_hello.F
120          program hello
121          write(*,*) 'hi'
122          stop
123          end
124    EOF
125        test -e Makefile  &&  mv -f Makefile Makefile.bak
126        cat <<EOF >> Makefile
127    %.$tfs : %.F
128    .SUFFIXES:
129    genmake_hello.$tfs: genmake_hello.F
130            $LN genmake_hello.F genmake_hello.$tfs
131    EOF
132        $MAKE "genmake_hello."$tfs > /dev/null 2>&1
133        RETVAL=$?
134        if test "x$RETVAL" != x0 -o ! -e "genmake_hello."$tfs ; then
135            if test "x$FS" = x ; then
136                FS='for'
137                FS90='fr9'
138                check_for_broken_Ff
139            else
140                cat <<EOF 2>&1
141    ERROR: Your file system cannot distinguish between *.F and *.f files
142      (fails the "make/ln" test) and this program cannot find a suitable
143      replacement extension.  Please try a different build environment or
144      contact the <MITgcm-support@mitgcm.org> list for help.
145    
146    EOF
147                exit -1
148                return
149            fi
150        fi
151        rm -f genmake_hello.* Makefile
152        test -e Makefile  &&  mv -f Makefile.bak Makefile
153    
154        #  If we make it here, use the extensions
155        FS=$tfs
156        FS90=$tfs9
157        return
158    }
159    
160    
161  # Guess possible config options for this host  # Guess possible config options for this host
162  find_possible_configs()  {  find_possible_configs()  {
163    
# Line 80  find_possible_configs()  { Line 166  find_possible_configs()  {
166      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
167      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
168      tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
169      PLATFORM=$tmp2      tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
170        PLATFORM=$tmp3
171        echo $PLATFORM | grep cygwin > /dev/null 2>&1  &&  PLATFORM=cygwin_ia32
172      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
173      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
174            
# Line 119  find_possible_configs()  { Line 207  find_possible_configs()  {
207      #    4) fall back to the buggy local xmakedpend script      #    4) fall back to the buggy local xmakedpend script
208      #      #
209      if test "x${MAKEDEPEND}" = x ; then      if test "x${MAKEDEPEND}" = x ; then
210        which makedepend >& /dev/null        which makedepend > /dev/null 2>&1
211        RETVAL=$?        RV0=$?
212        if test ! "x${RETVAL}" = x0 ; then        cat <<EOF >> genmake_tc.f
213          program test
214          write(*,*) 'test'
215          stop
216          end
217    EOF
218          makedepend genmake_tc.f > /dev/null 2>&1
219          RV1=$?
220          if test ! "x${RV0}${RV1}" = x00 ; then
221           echo "    a system-default makedepend was not found."           echo "    a system-default makedepend was not found."
222    
223           #  Try to build the cyrus impl           #  Try to build the cyrus impl
# Line 129  find_possible_configs()  { Line 225  find_possible_configs()  {
225           (           (
226               cd $ROOTDIR/tools/cyrus-imapd-makedepend  \               cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
227                   &&  ./configure > /dev/null 2>&1  \                   &&  ./configure > /dev/null 2>&1  \
228                   &&  make > /dev/null 2>&1  \                   &&  make > /dev/null 2>&1
229                   &&  ./makedepend ifparser.c > /dev/null 2>&1  \               if test -x ./makedepend.exe ; then
230                     $LN ./makedepend.exe ./makedepend
231                 fi
232                 ./makedepend ifparser.c > /dev/null 2>&1  \
233                   &&  echo "true"                   &&  echo "true"
234           ) > ./genmake_cy_md           ) > ./genmake_cy_md
235           grep true ./genmake_cy_md > /dev/null 2>&1           grep true ./genmake_cy_md > /dev/null 2>&1
# Line 272  Usage: "$0" [OPTIONS] Line 371  Usage: "$0" [OPTIONS]
371      -help | --help | -h | --h      -help | --help | -h | --h
372            Print this help message and exit.            Print this help message and exit.
373    
374        -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
375          -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
376              Use "NAME" as the adoptfile.  By default, the file at
377              "tools/adjoint_options/adjoint_default" will be used.
378    
379      -nooptfile | --nooptfile      -nooptfile | --nooptfile
380        -optfile NAME | --optfile NAME | -of NAME | --of NAME        -optfile NAME | --optfile NAME | -of NAME | --of NAME
381        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
# Line 495  EOF Line 599  EOF
599    
600    
601  check_netcdf_libs()  {  check_netcdf_libs()  {
602      cat <<EOF > genmake_tnc.F      cat <<EOF > genmake_tnc.for
603        program fgennc        program fgennc
604  #include "netcdf.inc"  #include "netcdf.inc"
605        integer iret, ncid, xid        integer iret, ncid, xid
# Line 507  check_netcdf_libs()  { Line 611  check_netcdf_libs()  {
611        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
612        end        end
613  EOF  EOF
614      $CPP genmake_tnc.F > genmake_tnc.f  \      $CPP genmake_tnc.for > genmake_tnc.f  \
615          &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1          &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1
616      RET_COMPILE=$?      RET_COMPILE=$?
617      test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1      test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
# Line 516  EOF Line 620  EOF
620          HAVE_NETCDF=t          HAVE_NETCDF=t
621      else      else
622          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
623          $CPP genmake_tnc.F > genmake_tnc.f  \          $CPP genmake_tnc.for > genmake_tnc.f  \
624              &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \              &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \
625              $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1              $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1
626          RET_COMPILE=$?          RET_COMPILE=$?
# Line 578  HAVE_FDATE= Line 682  HAVE_FDATE=
682  FC_NAMEMANGLE=  FC_NAMEMANGLE=
683  HAVE_CLOC=  HAVE_CLOC=
684  HAVE_NETCDF=  HAVE_NETCDF=
685    HAVE_ETIME=
686    
687  MODS=  MODS=
688  TOOLSDIR=  TOOLSDIR=
# Line 585  SOURCEDIRS= Line 690  SOURCEDIRS=
690  INCLUDEDIRS=  INCLUDEDIRS=
691  STANDARDDIRS="USE_THE_DEFAULT"  STANDARDDIRS="USE_THE_DEFAULT"
692    
693    G2ARGS=
694  BASH=  BASH=
695  PWD=`pwd`  PWD=`pwd`
696  MAKE=make  MAKE=make
# Line 601  IEEE= Line 707  IEEE=
707  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
708      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
709  fi  fi
710    FS=
711    FS90=
712    
713  AUTODIFF_PKG_USED=f  AUTODIFF_PKG_USED=f
714  AD_OPTFILE=  AD_OPTFILE=
# Line 625  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPE Line 733  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPE
733  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
734  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
735  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
736  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE"  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
737    
738  #  The following are all related to adjoint/tangent-linear stuff  #  The following are all related to adjoint/tangent-linear stuff
739  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
# Line 678  fi Line 786  fi
786  ac_prev=  ac_prev=
787  for ac_option ; do  for ac_option ; do
788    
789        G2ARGS="$G2ARGS \"$ac_option\""
790    
791      # If the previous option needs an argument, assign it.      # If the previous option needs an argument, assign it.
792      if test -n "$ac_prev"; then      if test -n "$ac_prev"; then
793          eval "$ac_prev=\$ac_option"          eval "$ac_prev=\$ac_option"
# Line 776  for ac_option ; do Line 886  for ac_option ; do
886          -fc=* | --fc=*)          -fc=* | --fc=*)
887              FC=$ac_optarg ;;              FC=$ac_optarg ;;
888                    
889            -fs | --fs)
890                ac_prev=FS ;;
891            -fs=* | --fs=*)
892                FS=$ac_optarg ;;
893            
894            -fs90 | --fs90)
895                ac_prev=FS90 ;;
896            -fs90=* | --fs90=*)
897                FS90=$ac_optarg ;;
898            
899          -ieee | --ieee)          -ieee | --ieee)
900              IEEE=true ;;              IEEE=true ;;
901          -noieee | --noieee)          -noieee | --noieee)
# Line 885  if test "x$OPTFILE" != xNONE ; then Line 1005  if test "x$OPTFILE" != xNONE ; then
1005      fi      fi
1006  fi  fi
1007    
1008    #  Check for broken systems that cannot correctly distinguish *.F and *.f files
1009    # check_for_broken_Ff
1010    
1011  echo "  getting AD_OPTFILE information:  "  echo "  getting AD_OPTFILE information:  "
1012  if test "x${AD_OPTFILE}" = x ; then  if test "x${AD_OPTFILE}" = x ; then
1013      if test "x$MITGCM_AD_OF" = x ; then      if test "x$MITGCM_AD_OF" = x ; then
# Line 938  if test "x$CPP" = x ; then Line 1061  if test "x$CPP" = x ; then
1061      CPP=cpp      CPP=cpp
1062  fi  fi
1063  #EH3 === UGLY ===  #EH3 === UGLY ===
1064  #  The following an ugly little hack to check for $CPP in /lib/ and it  #  The following is an ugly little hack to check for $CPP in /lib/ and
1065  #  should eventually be replaced with a more general function that  #  it should eventually be replaced with a more general function that
1066  #  searches a combo of the user's path and a list of "usual suspects"  #  searches a combo of the user's path and a list of "usual suspects"
1067  #  to find the correct location for binaries such as $CPP.  #  to find the correct location for binaries such as $CPP.
1068  for i in " " "/lib/" ; do  for i in " " "/lib/" ; do
# Line 982  EOF Line 1105  EOF
1105  fi  fi
1106  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
1107    
1108    #  Check for broken *.F/*.f handling and fix if possible
1109    check_for_broken_Ff
1110    
1111  if test ! "x$MPI" = x ; then  if test ! "x$MPI" = x ; then
1112        echo "  Turning on MPI cpp macros"        echo "  Turning on MPI cpp macros"
1113        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
# Line 1027  else Line 1153  else
1153  fi  fi
1154  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1155    
1156    printf "  Do we have the etime() command using $FC...  "
1157    cat > genmake_tcomp.f <<EOF
1158          program hello
1159          REAL*4 ACTUAL, TARRAY(2)
1160          EXTERNAL ETIME
1161          REAL*4 ETIME
1162          actual = etime( tarray )
1163          print *, tarray
1164          end
1165    EOF
1166    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1167    RETVAL=$?
1168    if test "x$RETVAL" = x0 ; then
1169        HAVE_ETIME=t
1170        DEFINES="$DEFINES -DHAVE_ETIME"
1171        echo "yes"
1172    else
1173        HAVE_ETIME=
1174        echo "no"
1175    fi
1176    rm -f genmake_tcomp*
1177    
1178  printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "  printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
1179  check_HAVE_CLOC  check_HAVE_CLOC
1180  if test "x$HAVE_CLOC" != x ; then  if test "x$HAVE_CLOC" != x ; then
# Line 1186  else Line 1334  else
1334              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1335          done          done
1336          echo "    before group expansion packages are: $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1337          expand_pkg_groups          while ! expand_pkg_groups; do echo > /dev/null; done
1338          echo "    after group expansion packages are:  $PACKAGES"          echo "    after group expansion packages are:  $PACKAGES"
1339      fi      fi
1340  fi  fi
1341    
1342  echo "  applying DISABLE settings"  echo "  applying DISABLE settings"
1343    for i in $PACKAGES ; do
1344        echo $i >> ./.tmp_pack
1345    done
1346    for i in `grep  "-" ./.tmp_pack` ; do
1347        j=`echo $i | sed 's/[-]//'`
1348        DISABLE="$DISABLE $j"
1349    done
1350  pack=  pack=
1351  for p in $PACKAGES ; do  for p in $PACKAGES ; do
1352      addit="t"      addit="t"
# Line 1208  PACKAGES="$pack" Line 1363  PACKAGES="$pack"
1363  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
1364  echo "" > ./.tmp_pack  echo "" > ./.tmp_pack
1365  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
1366    # Test if each explicitly referenced package exists
1367  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1368      if test ! -d "$ROOTDIR/pkg/$i" ; then      j=`echo $i | sed 's/[-+]//'`
1369        if test ! -d "$ROOTDIR/pkg/$j" ; then
1370          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1371          exit 1          exit 1
1372      fi      fi
1373      echo $i >> ./.tmp_pack      echo $i >> ./.tmp_pack
1374  done  done
 pack=`cat ./.tmp_pack | sort | uniq`  
 rm -f ./.tmp_pack  
1375  PACKAGES=  PACKAGES=
1376  for i in $pack ; do  for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1377      PACKAGES="$PACKAGES $i"      PACKAGES="$PACKAGES $i"
1378  done  done
1379    rm -f ./.tmp_pack
1380  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1381    
1382  echo "  applying package dependency rules"  echo "  applying package dependency rules"
# Line 1535  echo "#    $MACHINE" >> $MAKEFILE Line 1691  echo "#    $MACHINE" >> $MAKEFILE
1691  echo "# This makefile was generated automatically on" >> $MAKEFILE  echo "# This makefile was generated automatically on" >> $MAKEFILE
1692  echo "#    $THISDATE" >> $MAKEFILE  echo "#    $THISDATE" >> $MAKEFILE
1693  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
1694  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
1695  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1696  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE
1697    
# Line 1635  cat csrclist.inc      >> $MAKEFILE Line 1791  cat csrclist.inc      >> $MAKEFILE
1791  cat f90srclist.inc    >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
1792  cat hlist.inc         >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
1793  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
1794  echo               >> $MAKEFILE  echo >> $MAKEFILE
1795  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
1796  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE
1797  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1798    echo >> $MAKEFILE
1799    echo '.SUFFIXES:' >> $MAKEFILE
1800    echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE
1801  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1802  rm -f ad_flow_files.inc  rm -f ad_flow_files.inc
1803    
1804  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1805    
 .SUFFIXES:  
 .SUFFIXES: .o .f .p .F .c .F90 .f90  
   
1806  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1807  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1808          @echo Creating \$@ ...          @echo Creating \$@ ...
1809          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1810  depend:  depend:
1811          @make links          @make links
1812          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1813          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1814            -rm -f makedepend.out
1815    
1816  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1817    
# Line 1666  output.txt: \$(EXECUTABLE) Line 1822  output.txt: \$(EXECUTABLE)
1822          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1823    
1824  clean:  clean:
1825          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
1826  Clean:  Clean:
1827          @make clean          @make clean
1828          @make cleanlinks          @make cleanlinks
# Line 1677  CLEAN: Line 1833  CLEAN:
1833          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
1834          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
1835          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1836          -rm -f \$(EXECUTABLE) output.txt          -rm -f \$(EXECUTABLE) output.txt STD*
1837    
1838  #eh3 Makefile: makefile  #eh3 Makefile: makefile
1839  makefile:  makefile:
1840          $THIS_SCRIPT $@          $THIS_SCRIPT $G2ARGS
1841  cleanlinks:  cleanlinks:
1842          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1843    
# Line 1696  FC_NAMEMANGLE.h: Line 1852  FC_NAMEMANGLE.h:
1852          @echo Creating \$@ ...          @echo Creating \$@ ...
1853          echo "$FC_NAMEMANGLE" > \$@          echo "$FC_NAMEMANGLE" > \$@
1854    
1855  # The normal chain of rules is (  .F - .f - .o  )  # The normal chain of rules is (  .F - .$FS - .o  )
1856  .F.f:  
1857    %.o : %.F
1858    
1859    .F.$FS:
1860          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1861  .f.o:  .$FS.o:
1862          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
1863  .F90.f90:  .F90.$FS90:
1864          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1865  .f90.o:  .$FS90.o:
1866          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
1867  .c.o:  .c.o:
1868          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) -c \$<
1869    
1870  # Special exceptions that use the ( .F - .p - .f - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
1871  .F.p:  .F.p:
1872          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1873  .p.f:  .p.$FS:
1874          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
1875    
1876  #=========================================  #=========================================
# Line 1836  for i in $KPPFILES ; do Line 1995  for i in $KPPFILES ; do
1995      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
1996          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
1997      fi      fi
1998      echo "$base.f: $base.p" >> $MAKEFILE      echo "$base.$FS: $base.p" >> $MAKEFILE
1999  done  done
2000    
2001  echo "  Making list of NOOPTFILES"  echo "  Making list of NOOPTFILES"
# Line 1846  for i in $NOOPTFILES ; do Line 2005  for i in $NOOPTFILES ; do
2005      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2006          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2007      fi      fi
2008      echo "$base.o: $base.f" >> $MAKEFILE      echo "$base.o: $base.$FS" >> $MAKEFILE
2009      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
2010  done  done
2011    

Legend:
Removed from v.1.71  
changed lines
  Added in v.1.83

  ViewVC Help
Powered by ViewVC 1.1.22